;
; LOD Player Version 2
;
; 1Cf2
; 1D8f
;
F1LO	= $FF0E
F1HI	= $FF12
F2LO	= $FF0F
F2HI	= $FF10

OFF	= $47
	
; COMMAND BYTES

END_MARK	= $FE
SET_VOLTAB	= $FF
STOP		= $FD
DIGI_START	= $FC
SETINS		= $F0
LEN		= $50

; Constants
base_note = -4 ; shift to C0
C0	= base_note + 0
Ci0	= base_note + 1
D0	= base_note + 2
Di0	= base_note + 3
E0	= base_note + 4
F0	= base_note + 5
Fi0	= base_note + 6
G0	= base_note + 7
Gi0	= base_note + 8
A0	= base_note + 9
Ai0	= base_note + 10
B0	= base_note + 11

C1	= base_note + 12
Ci1	= base_note + 13
D1	= base_note + 14
Di1	= base_note + 15
E1	= base_note + 16
F1	= base_note + 17
Fi1	= base_note + 18
G1	= base_note + 19
Gi1	= base_note + 20
A1	= base_note + 21
Ai1	= base_note + 22
B1	= base_note + 23

C2	= base_note + 24
Ci2	= base_note + 25
D2	= base_note + 26
Di2	= base_note + 27
E2	= base_note + 28
F2	= base_note + 29
Fi2	= base_note + 30
G2	= base_note + 31
Gi2	= base_note + 32
A2	= base_note + 33
Ai2	= base_note + 34
B2	= base_note + 35

C3	= base_note + 36
Ci3	= base_note + 37
D3	= base_note + 38
Di3	= base_note + 39
E3	= base_note + 40
F3	= base_note + 41
Fi3	= base_note + 42
G3	= base_note + 43
Gi3	= base_note + 44
A3	= base_note + 45
Ai3	= base_note + 46
B3	= base_note + 47

C4	= base_note + 48
Ci4	= base_note + 49
D4	= base_note + 50
Di4	= base_note + 51
E4	= base_note + 52
F4	= base_note + 53
Fi4	= base_note + 54
G4	= base_note + 55
Gi4	= base_note + 56
A4	= base_note + 57
Ai4	= base_note + 58
B4	= base_note + 59

C5	= base_note + 60
Ci5	= base_note + 61
D5	= base_note + 62

;-----

	align 256
freqs
	db $07,$00,$40,$00,$76,$00,$A9,$00,$D9,$00,$06,$01,$31,$01,$59,$01
	db $7F,$01,$A3,$01,$C5,$01,$E5,$01,$04,$02,$20,$02,$3B,$02,$54,$02
	db $6C,$02,$83,$02,$98,$02,$AD,$02,$C0,$02,$D2,$02,$E3,$02,$F3,$02
	db $02,$03,$10,$03,$1E,$03,$2A,$03,$36,$03,$42,$03,$4C,$03,$56,$03
	db $60,$03,$69,$03,$71,$03,$79,$03,$81,$03,$88,$03,$8F,$03,$95,$03
	db $9B,$03,$A1,$03,$A6,$03,$AB,$03,$B0,$03,$B4,$03,$B9,$03,$BD,$03
	db $C0,$03,$C4,$03,$C7,$03,$CB,$03,$CE,$03,$D0,$03,$D3,$03,$D6,$03
	db $D8,$03,$DA,$03,$DC,$03,$DE,$03,$E0,$03,$E2,$03,$E4,$03,$E5,$03
	db $E7,$03,$E8,$03,$EA,$03,$EB,$03,$EC,$03,$ED,$03,$EE,$03,$FE,$03

;volume_map
;	db $10,$11,$12,$13,$14,$15,$16,$17,$18
;	db $10,$11,$12,$13,$14,$15,$16,$17,$18
;	db $10,$11,$12,$13,$14,$15,$15,$16,$17
;	db $10,$11,$12,$13,$13,$14,$15,$16,$17
;	;
;	db $10,$11,$12,$12,$13,$14,$15,$16,$16
;	db $10,$11,$12,$12,$13,$14,$15,$15,$16
;	db $10,$11,$11,$12,$13,$14,$14,$15,$16
;	db $10,$11,$11,$12,$13,$13,$14,$15,$15
;	;
;	db $10,$11,$11,$12,$12,$13,$14,$14,$15
;	db $10,$11,$11,$12,$12,$13,$13,$14,$14
;	db $10,$11,$11,$12,$12,$13,$13,$14,$14
;	db $10,$10,$11,$11,$12,$12,$13,$13,$14
;	;
;	db $10,$10,$11,$11,$12,$12,$12,$13,$13
;	db $10,$10,$11,$11,$11,$12,$12,$12,$13
;	db $10,$10,$11,$11,$11,$12,$12,$12,$12
;	db $10,$10,$11,$11,$11,$11,$12,$12,$12
;	;
;	db $10,$10,$10,$11,$11,$11,$11,$11,$12
;	db $10,$10,$10,$10,$11,$11,$11,$11,$11
;	db $10,$10,$10,$10,$10,$11,$11,$11,$11
;	db $10,$10,$10,$10,$10,$10,$10,$10,$11
;	;
;	db $10,$10,$10,$10,$10,$10,$10,$10,$10	; 21
	
;arpeggio
;	db 0,0,0
;[eof]
          
	;ALIGN 256
PLAYER_FREQ_INIT
	;         
	; *** Freq init
	;
	ldx #(Channel1) & 255
	ldy #(Channel1) >> 8
	stx PCH1_LO
	sty PCH1_HI
	;
	ldx #(Channel2) & 255
	ldy #(Channel2) >> 8
	stx PCH2_LO
	sty PCH2_HI
	;
	ldx #(Channel3) & 255
	ldy #(Channel3) >> 8
	stx PCH3_LO
	sty PCH3_HI
	;
	ldx #$FF
	stx VOLTAB_CNT
	inx       
	stx NOTE1
	stx NOTE2
	stx NOTE3
	jsr res
	inx		; x=1
	stx NOTELEN1
	stx NOTELEN2
	stx NOTELEN3
	stx note_length
	jsr res
	inx		; x=2
	jsr res
	;
	;lda #9*0
	;sta VOLUME
	;
	rts

res	ldy #$00
	db $2C
	
advance	ldy PCH1,x
	;      
	lda PCH1_LO,x
	sta PCH_TEMP
	lda PCH1_HI,x
	sta PCH_TEMP+1
	;
	lda (PCH_TEMP),y	; LO byte
	sta CH1_LO,x
	iny
	lda (PCH_TEMP),y	; HI byte
	beq res
	sta CH1_HI,x
	iny
	sty PCH1,x
	rts
	
	;
	;##################
	;

PLAYER
	ldx #$02
	;
channel_loop
	inc NOTE1,x
	;
	lda NOTE1,x
	cmp NOTELEN1,x
	beq next_note
	jmp channel_loop_end
	;
next_note 
	lda CH1_LO,x
	sta CH_TEMP
	lda CH1_HI,x
	sta CH_TEMP+1
	;
	ldy #$00
	sty NOTE1,x		; reset note counter
	;   
	lda (CH_TEMP),y		; get byte
	iny
	;
	cmp #END_MARK		; $FF goes to new pattern
	bne pl_10
	;
	jsr advance
	bne next_note		; should never be zero
	;
pl_10	cmp #SET_VOLTAB
	bne pl_12
	;
	sta VOLTAB_CNT
	;
	lda (CH_TEMP),y		; get lo byte
	iny
	sta VOL_TAB+1
	;
	lda (CH_TEMP),y		; get byte
	iny
	;
pl_12	
	cmp #STOP
	bne pl_13
	;
	lda #$60		; RTS opcode
	sta PLAYER
	;
	lda (CH_TEMP),y		; get byte
	iny
	;
pl_13	
	cmp #DIGI_START
	bne pl_14
	;
	tya
	pha
	jsr digi_init
	pla
	tay
	;
	lda (CH_TEMP),y		; get byte
	iny
	;
pl_14	
	cmp #SETINS		; instrument change?
	bcc pl_01
	;
	and #$0F		; keep lower 4 bits
	sta INS_TYPE1,x   	; store instrument type
	;
	lda (CH_TEMP),y		; get byte
	iny
	;
pl_01	cmp #LEN		; set note length?
	bcc pl_02
	;
	sbc #LEN		; we know carry is always set
	sta NOTELEN1,x
	;
	lda (CH_TEMP),y
	iny
	;
pl_02	; - store note!
	;
	sta TONE1,x
	;
	; --- advance pointer
	;
	tya
	clc
	adc CH1_LO,x
	sta CH1_LO,x
	bcc noi_1
	inc CH1_HI,x
noi_1	;
	;
	; -----------------------------------------------------------------
	;
channel_loop_end
	dex
	bmi pl_50
	jmp channel_loop
	;    
pl_50	
	;
	; --- SOUND PROCESSING
	;
PLAYER_SOUND
	lda #$20
	sta NOISE
	;
	ldx #$02		; channel 3
	jsr sound
	;
	cmp #$FE
	bne do_ch2
	;
	ldx #$01		; channel 2
	jsr sound
	;
do_ch2	sta F1LO_store+1
	sty F1HI_x+1
	;
	lda F1HI
	and #$FC
F1HI_x	ora #$00
	sta F1HI_store+1
	;
	ldx #$00		; channel 1
	jsr sound
	sta F2LO
	sty F2HI
	;
F1LO_store
	lda #$00
	sta F1LO
F1HI_store
	lda #$00
	sta F1HI
	;
	; ---
	;
	ldy VOLTAB_CNT
	iny
res_v	
VOL_TAB	lda vol_default,y
	bpl noi_v		; check for $FF
	ldy #$00		; reached, so warp
	beq res_v
noi_v	sty VOLTAB_CNT
	;clc
	;adc VOLUME
	;tay
	;lda volume_map,y
	ora #$10
	ora NOISE
	;
	ldy F1LO
	cpy #$FE
	bne setvol		; not silent
	ldy F2LO
	cpy #$FE
	beq sil			; silent: skip setting $FF11 to avoid clicks
	;
setvol	sta $FF11		; self-mod
	;
sil     
PLAYER_DIGI
	lda note_length		; for digi: DEC = digi is playing, LDA = stop digi
	bne pl60
	
read_nextbyte
	ldy #$00
	sty digi_step
	sty $FFFF		; DIGI_IRQ (relocated address!) back to normal digi playing
	;
	lda (digi_pattern),y	; first byte: sample digi_address high (or zero for repeat)
	beq digi_patternEnd
	;
	sta digi_addr+2
	sty digi_addr+1
	;
	inc digi_pattern
	bne *+4
	inc digi_pattern+1
	;       
	lda (digi_pattern),y	; 2nd byte: total sample length
	sta sample_length
	;
	inc digi_pattern
	bne *+4
	inc digi_pattern+1
	;
	lda (digi_pattern),y	; 3rd byte: note length
	sta note_length
	;
	inc digi_pattern
	bne *+4
	inc digi_pattern+1
	;
	; ----------
	;
pl60	rts
	;
restart_order
	lda #Channel4 & 255
	sta digi_order
	;
	lda #Channel4 >> 8
	sta digi_order + 1
	;                
digi_patternEnd
	lda (digi_order),y
	sta digi_pattern
	;                            
	inc digi_order
	;
	lda (digi_order),y
	sta digi_pattern + 1
	;
	beq restart_order
	;
	inc digi_order
	;
	jmp read_nextbyte     
	;
inst_table
	dw normal		; $F0
	dw normal		; $F1
	dw snare		; $F2
	dw blipp		; $F3
	dw normal		; $F4
	dw vib1			; $F5
	dw normal		; $F6
	dw vib3			; $F7
	;
sound	lda TONE1,x
	cmp #OFF
	beq lookup
	;
	lda INS_TYPE1,x
	asl a
	tay
	lda inst_table,y
	sta inst_jump+1
	lda inst_table+1,y
	sta inst_jump+2
	;
inst_jump
	jmp $0000
	
normal	lda TONE1,x		; normal note
lookup	asl a
	tax
	lda freqs,x
	ldy freqs+1,x
	rts
	
blipp	
	lda TONE1,x
	ldy NOTE1,x
	beq lookup
	
	cpy #$02
	bcs blipp_off
	
	clc
	adc #$0C
	bne lookup
	
blipp_off
	lda #OFF
	bne lookup
	;
;arp
;	lda ARP_CNT		; load current arp counter
;	clc
;	adc #$01
;arplen	cmp #$06		; auto reset every 6 frames (n1,n1,n2,n2,n3,n3)
;	bne *+4
;	lda #$00
;	sta ARP_CNT
;	lsr a
;	tay
;	lda arpeggio,y	; for channel 2 (self-mod)
;	clc
;	adc TONE1,x
;	bne lookup
	
vib3	lda NOTE1,x
	and #$07
	tay
	lda vibrato3,y
	jmp vib0
	
;vib2	lda NOTE1,x
;	and #$07
;	tay
;	lda vibrato2,y
;	jmp vib0

vib1	lda NOTE1,x
	and #$07
	tay
	lda vibrato1,y
vib0	bmi vibsub
	;
	sta vibtmp1+1
	;
	lda TONE1,x
	asl a
	tax
	ldy freqs+1,x
	lda freqs,x
	clc
vibtmp1	adc #$01
	bcc *+3
	iny
	rts
	;
vibsub	and #$7F
	;      
	sta vibtmp2+1
	;
	lda TONE1,x
	asl a
	tax
	ldy freqs+1,x
	lda freqs,x
	sec
vibtmp2	sbc #$01
	bcs *+3
	dey
	rts
	
vibrato1
	db $00,$01,$02,$01
	db $00,$81,$82,$81
;vibrato2
;	db $00,$02,$03,$02
;	db $00,$82,$83,$82
vibrato3
	db $00,$05,$07,$05
	db $00,$85,$87,$85	
	
;bassdrum
;	;lda #$40		; turn on noise bit
;	;sta NOISE
;	;
;	lda NOTE1,x		; look up note freq
;	asl a
;	tax
;	;
;	lda bass_freq+1,x	; take 16 bit values as-is
;	tay
;	lda bass_freq,x
;	rts
	
snare	
	lda #$40		; turn on noise bit
	sta NOISE
	;
	lda TONE1,x		; look up note freq
	asl a
	tay
	;
	lda NOTE1,x
	tax
	lda snare_freq,x	; 16 bit add: add snare freq
	clc        
	adc freqs,y       
	pha
	lda freqs+1,y
	tay
	pla
	rts
	
	;
	; ---
	;
digi_init
	ldx #DIGI_IRQ_NULL_end-DIGI_IRQ_NULL
irqc1	lda DIGI_IRQ_NULL,x		; copy irq to $0108 area
	sta $0108,x
	dex
	bpl irqc1
	;
	ldx #DIGI_IRQ_end - DIGI_IRQ - 1
irqc2	lda DIGI_IRQ,x
	sta $08,x
	dex
	bpl irqc2
	;
	; ---
	;
	ldy #$00
	sty digi_step
	ldx #$40		; digi speed: both for NTSC and PAL
	stx $FF00		; set digi speed
	sty $FF01
	;  
	; ***
	;          
	lda #Channel4 & 255
	ldx #Channel4 >> 8
	sta digi_order
	stx digi_order + 1
	;                
	lda (digi_order),y	; preload first pattern pointer
	sta digi_pattern
	;
	inc digi_order
	;
	lda (digi_order),y
	sta digi_pattern + 1
	;
	inc digi_order
	;   
	lda (digi_pattern),y	; first byte: sample address high (or zero for repeat)
	sta digi_addr+2
	sty digi_addr+1		; low byte always zero
	;
	inc digi_pattern
	;       
	lda (digi_pattern),y	; 2nd byte: total sample length
	sta sample_length
	;
	inc digi_pattern
	;
	lda (digi_pattern),y	; 3rd byte: note length
	sta note_length
	;
	inc digi_pattern
	;
	lda #$C6
	sta PLAYER_DIGI
	;
	lda #$08
	ldx #$00
	ldy #$A9
	sta $FFFE
	stx $FFFF
	sty $FF0A
	;
	inc $FF09
	;
	rts
	
	;
	; #####################
	;
DIGI_IRQ
	pha
	lda $FF11		; +05 - (4) self-mod
	sta $FF11		; (4) set Volume: play digi
	;
	inc digi_addr+1		; (5)
	bne id_noinc		; (3) if taken
	inc digi_addr+2		;
	;
	dec sample_length
	bne id_noinc
	;
	inc $FFFF		; go to DIGI_IRQ_NULL from now on
	;
id_noinc
	inc $FF09
	pla
	rti			; (6)
DIGI_IRQ_end	
	;
	; #####################
	;
DIGI_IRQ_NULL
	inc $FF09
	rti
DIGI_IRQ_NULL_end
;[eof]