timeline_ptr	= $D0
timeline_delay	= $D2

timeline_process_1
	jsr timeline_progress
timeline_process
	lda timeline_delay
	ora timeline_delay+1
	beq timeline_process_1	; when the delay reaches zero, progress
	;
	lda timeline_delay
	sec
	sbc #$01		; always count down
	sta timeline_delay
	lda timeline_delay+1
	sbc #$00
	sta timeline_delay+1 
timeline_call
	jmp nothing		; and call

timeline_reset
	lda #timeline & 255
	sta timeline_ptr
	lda #timeline >> 8
	sta timeline_ptr+1
timeline_progress
	ldy #$00		; get 4 bytes from the timeline table
	lda (timeline_ptr),y	; first two bytes: "length" (in frames)
	sta timeline_delay
	iny 
	lda (timeline_ptr),y
	sta timeline_delay+1
	iny
	lda (timeline_ptr),y	; next 2 bytes: function to call
	sta timeline_call+1
	iny 
	lda (timeline_ptr),y
	sta timeline_call+2
	iny
	tya
	clc
	adc timeline_ptr	; advance the pointer
	sta timeline_ptr
	lda timeline_ptr+1
	adc #$00
	sta timeline_ptr+1
nothing	rts
;eod